#include "imageoperationbeauty.h"
#include "../beauty.h"
#include "../include/common.h"
#include <QDebug>


ImageOperationBeauty::ImageOperationBeauty(QImage *origin, QStack<QImage> *stackImage)
{
    m_origin = origin;
    m_stackImage = stackImage;
    isInterupt = false;
}
void ImageOperationBeauty::ImageOP(){
    QImage res = imageCopy(m_origin,m_stackImage);
    cv::Mat target = Image2Mat(&res);
    beauty(target);
    emit finished();
}
void ImageOperationBeauty::beauty(cv::Mat src){
    Mat dst;
    if (!src.data) {
        qDebug() << ScanningPicture << "image load error!";
        return;
    }
    if(isInterupt){
        return;
    }
    bilateralFilterCV(src, dst);
    if(isInterupt){
        return;
    }
    luminanceContrastCV(dst, dst);
    if(isInterupt){
        return;
    }
    hslCV(dst, dst);
    if(isInterupt){
        return;
    }
    sharpenCV(dst, dst);
    if(isInterupt){
        return;
    }
    imwrite(ScanningPicture, dst);
}
cv::Mat ImageOperationBeauty::Image2Mat(QImage *img){
    cv::Mat res;
    switch (img->format()){
    case QImage::Format_ARGB32_Premultiplied:
        res = cv::Mat(img->height(),img->width(),CV_8UC4,(uchar*)img->bits(),img->bytesPerLine());
        break;
    case QImage::Format_RGB888:
        res = cv::Mat(img->height(),img->width(),CV_8UC3,(uchar*)img->bits(),img->bytesPerLine());
        break;
    case QImage::Format_Indexed8:
    case QImage::Format_Grayscale8:
        res = cv::Mat(img->height(),img->width(),CV_8UC1,(uchar*)img->bits(),img->bytesPerLine());
        cvtColor(res,res,CV_GRAY2BGR);
        break;
    case QImage::Format_RGB32:
        res = cv::Mat(img->height(),img->width(),CV_8UC4,(uchar*)img->bits(),img->bytesPerLine());
        cvtColor(res,res,CV_BGRA2BGR);
        break;

    default:
        qDebug() << "image format:" << img->format();
        *img = img->convertToFormat(QImage::Format_RGB32);
        res = Mat(img->height(),img->width(),CV_8UC4,const_cast<uchar*>(img->bits()),static_cast<size_t>(img->bytesPerLine()));
        cvtColor(res,res,CV_BGR2RGB);
    }
    return res;
}

