#include "imageoperationocr.h"
#include <tesseract/baseapi.h>
#include "../src/saneobject.h"
#include <leptonica/allheaders.h>
#include "../include/common.h"
#include <QDebug>


ImageOperationOCR::ImageOperationOCR(QImage *origin)
{
    m_origin = origin;
    isInterupt = false;
}
void ImageOperationOCR::ImageOP(){
    ocr();
    g_user_signal->toolbarOcrOperationFinished();
    emit finished();
}
void ImageOperationOCR::ocr(){
    qDebug() << "begin to run ocr thread !\n";
    m_origin->save(ScanningPicture);
    tesseract::TessBaseAPI  *api = new tesseract::TessBaseAPI();

    if (api->Init(NULL, "chi_sim")) {
        qDebug() << "Could not initialize tesseract.\n";
        g_sane_object->ocrOutputText = tr("Unable to read text");
        return;
    }
    if(isInterupt){
        if (api)
            api->End();
        return;
    }
    qDebug() << "before pixRead.";
    Pix *image = pixRead(ScanningPicture);
    if (! image) {
        qDebug() << "pixRead error!";
        g_sane_object->ocrOutputText = tr("Unable to read text");
        if (api)
            api->End();
        return;
    }
    if(isInterupt){
        if (api)
            api->End();
        return;
    }

    if (image) {
        qDebug() << "before setImage.";
        api->SetImage(image);
        g_sane_object->ocrOutputText = api->GetUTF8Text();
    }
    qDebug() << "before destroy image.";
    if (api) {
        api->End();
    }
    if (image) {
        pixDestroy(&image);
    }
}
