#include "imageoperationrectify.h"
#include "../src/rectify.h"
#include <QDebug>

ImageOperationRectify::ImageOperationRectify(QImage *origin, QStack<QImage> *stackImage)
{
    m_origin = origin;
    m_stackImage = stackImage;
    isInterupt = false;
}
void ImageOperationRectify::ImageOP(){
    QImage imgCopy = imageCopy(m_origin,m_stackImage);
    if(isInterupt){
        emit finished();
        return;
    }
    cv::Mat target = Image2Mat(&imgCopy);
    int res = 0;
    if(isInterupt){
        emit finished();
        return;
    }
    res = ImageRectify(&target);
    if(res == 0){
        qDebug() << "rectify success!";
    }else if(res == 1){
        qDebug() << "no need to rectify, success!";
        isInterupt = true;
    }else{
        qDebug() << "rectify exit!";
    }
    emit finished();
}
cv::Mat ImageOperationRectify::Image2Mat(QImage *img){
    cv::Mat res;
    switch (img->format()){
    case QImage::Format_ARGB32_Premultiplied:
        res = cv::Mat(img->height(),img->width(),CV_8UC4,(uchar*)img->bits(),img->bytesPerLine());
        break;
    case QImage::Format_RGB888:
        res = cv::Mat(img->height(),img->width(),CV_8UC3,(uchar*)img->bits(),img->bytesPerLine());
        break;
    case QImage::Format_Indexed8:
    case QImage::Format_Grayscale8:
        res = cv::Mat(img->height(),img->width(),CV_8UC1,(uchar*)img->bits(),img->bytesPerLine());
        cvtColor(res,res,CV_GRAY2BGR);
        break;
    case QImage::Format_RGB32:
        res = cv::Mat(img->height(),img->width(),CV_8UC4,(uchar*)img->bits(),img->bytesPerLine());
        cvtColor(res,res,CV_BGRA2BGR);
        break;

    default:
        qDebug() << "image format:" << img->format();
        *img = img->convertToFormat(QImage::Format_RGB32);
        res = Mat(img->height(),img->width(),CV_8UC4,const_cast<uchar*>(img->bits()),static_cast<size_t>(img->bytesPerLine()));
        cvtColor(res,res,CV_BGR2RGB);
    }
    return res;
}

