#ifndef SCANDIALOG_H
#define SCANDIALOG_H

#include <QWidget>
#include <QDialog>
#include <QSize>
#include <QPushButton>
#include <QLabel>
#include <QBoxLayout>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QVariant>

#define ScanDialogWindowSize QSize(380, 164)
#define ScanDialogIconSize QSize(26, 26)
#define ScanDialogLabelHeight 34
#define ScanDialogButtonSize QSize(96, 36)

#include "saneobject.h"

class ScanDialog : public QDialog
{
    Q_OBJECT
public:
    explicit ScanDialog(QWidget *parent = nullptr);

    void setupGui();
    void initConnect();

    int pageNumber() const;
    void setPageNumber(int pageNumber);

    QString scanMsg() const;
    void setScanMsg(const QString &scanMsg);

Q_SIGNALS:


public slots:
    void updatePageNumberWhileScanning();
    void updatePageNumberWhileStopScanning();


private:
    int m_pageNumber = 1;
    QString m_scanMsg;

    QLabel *m_titleLabel = nullptr;
    QPushButton *m_closeButton = nullptr;
    QLabel *m_iconLabel = nullptr;
    QLabel *m_msgLabel = nullptr;
    QPushButton *m_cancelButton = nullptr;

    QWidget *m_titleWidget = nullptr;
    QHBoxLayout *m_titleHBoxLayout = nullptr;
    QWidget *m_msgWidget = nullptr;
    QHBoxLayout *m_msgHBoxLayout = nullptr;
    QWidget *m_cancelWidget = nullptr;
    QHBoxLayout *m_cancelHBoxLayout = nullptr;
    QVBoxLayout *m_mainVBoxLayout = nullptr;

    bool isDarkTheme();
    void cancelOpration();


};

#endif // SCANDIALOG_H
